package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.shop.entity.Goods;
import com.gxwebsoft.shop.param.GoodsParam;
import com.gxwebsoft.shop.service.GoodsService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 商品记录表控制器
 *
 * @author 科技小王子
 * @since 2022-11-23 12:47:16
 */
@Api(tags = "商品记录表管理")
@RestController
@RequestMapping("/api/shop/goods")
public class GoodsController extends BaseController {
    @Resource
    private GoodsService goodsService;

    @PreAuthorize("hasAuthority('shop:goods:list')")
    @OperationLog
    @ApiOperation("分页查询商品记录表")
    @GetMapping("/page")
    public ApiResult<PageResult<Goods>> page(GoodsParam param) {
//        PageParam<Goods, GoodsParam> page = new PageParam<>(param);
//        page.setDefaultOrder("create_time desc");
//        return success(goodsService.page(page, page.getWrapper()));
        // 使用关联查询
        return success(goodsService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('shop:goods:list')")
    @OperationLog
    @ApiOperation("查询全部商品记录表")
    @GetMapping()
    public ApiResult<List<Goods>> list(GoodsParam param) {
//        PageParam<Goods, GoodsParam> page = new PageParam<>(param);
//        page.setDefaultOrder("create_time desc");
//        return success(goodsService.list(page.getOrderWrapper()));
        // 使用关联查询
        return success(goodsService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:goods:list')")
    @OperationLog
    @ApiOperation("根据id查询商品记录表")
    @GetMapping("/{id}")
    public ApiResult<Goods> get(@PathVariable("id") Integer id) {
        return success(goodsService.getById(id));
        // 使用关联查询
        //return success(goodsService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('shop:goods:save')")
    @OperationLog
    @ApiOperation("添加商品记录表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody Goods goods) {
        // 记录当前登录用户id、租户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          goods.setUserId(loginUser.getUserId());
        }
        if (goodsService.save(goods)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:goods:update')")
    @OperationLog
    @ApiOperation("修改商品记录表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody Goods goods) {
        if (goodsService.updateById(goods)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:goods:remove')")
    @OperationLog
    @ApiOperation("删除商品记录表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (goodsService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('shop:goods:save')")
    @OperationLog
    @ApiOperation("批量添加商品记录表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<Goods> list) {
        if (goodsService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:goods:update')")
    @OperationLog
    @ApiOperation("批量修改商品记录表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<Goods> batchParam) {
        if (batchParam.update(goodsService, "goods_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:goods:remove')")
    @OperationLog
    @ApiOperation("批量删除商品记录表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (goodsService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
